-- floodfilling an area of any shape demo.
-- by Jacques Deschenes
-- june 21th, 1997
--
without type_check
include graphics.e
include file.e

--with trace

integer WIDTH, HEIGHT

constant STACKLIM = 128000
constant Neighbours = {{-1,0},{0,-1},{1,0},{0,1}}

-- filling style constant
constant PLAIN=0, HORIZ = 1, VERTI=2, SLASH = 3, BKSLASH=4, CHESSB=5

function GetFColor(sequence p, object fill, integer style)
integer fcolor, fl , i
    if atom(fill) then
	return fill
    else
	fl = length(fill)
    end if
    if style = HORIZ then
      fcolor=fill[remainder(p[2],fl)+1]
    elsif style = VERTI then
      fcolor = fill[remainder(p[1],fl)+1]
    elsif style = SLASH then
      i = remainder(p[1]+remainder(p[2],fl),fl)+1
      if i < 1 then
	i = fl
      end if
      fcolor = fill[i]
    elsif style = BKSLASH then
      i = remainder(p[1]-remainder(p[2],fl),fl)+1
      if i < 1 then
	i = fl
      end if
      fcolor = fill[i]
    elsif style = CHESSB then
      i = remainder(p[1]-remainder(p[2],2),fl)+1
      if i < 1 then
	i = fl
      end if
      fcolor = fill[i]
    else -- assume plain
      fcolor = fill[1]
    end if
    return fcolor
end function

procedure Paint(sequence p,  -- Start point
		    integer border,   -- border color
		    object fill,  -- filling color or pattern
		    integer style -- filling style
		    )
sequence stack, -- stack
	 p0,N
integer stkptr, pcolor, fcolor, count

  pcolor = get_pixel(p)
  if pcolor = border then
    return
  end if
  stack=repeat(0,STACKLIM)
  stack[1] = p
  stkptr = 2
  pixel(GetFColor(p,fill,style),p)
  while stkptr > 1 do
    stkptr = stkptr - 1
    p0 = stack[stkptr]
    count = 0
    for i=1 to 4 do
      N = p0 + Neighbours[i]
      if N[1] < 0 or N[1] > WIDTH-1 or N[2] < 0 or N[2] > HEIGHT-1 then
	  pcolor = border
	  N = {0,0}
      else
	  pcolor = get_pixel(N)
      end if
      fcolor = GetFColor(N,fill,style)
      if pcolor != fcolor and pcolor != border then
	  pixel(fcolor,N)
	  stack[stkptr] = N
	  stkptr = stkptr + 1
	  count = count + 1
	  if stkptr >= STACKLIM then
	    --puts(1,"stack overflow\n")
	    --return  -- stack overflow
	    stkptr = stkptr-count
	  end if
      else
	  count = 0
      end if
     end for
  end while
end procedure --Paint()

procedure pause()
 position(11,1)
 puts(1,"Press a key to continue")
 while get_key()=-1 do
 end while
 position(11,1)
 puts(1,"                       ")
end procedure

atom junk
sequence vc
junk = graphics_mode(19)
if junk = -1 then
    abort(1)
end if
vc = video_config()
WIDTH = vc[VC_XPIXELS]
HEIGHT = vc[VC_YPIXELS]
-- draw ellipse
ellipse(BLUE,0,{10,10},{40,40})
-- fill ellipse
Paint({25,25},BLUE,GREEN,PLAIN)
-- draw polygon
constant poly = {{100,100},{150,100},{150,130},{160,130},{160,140},{150,150},
{130,150},{140,140},{140,130},{130,130},{120,150},{120,120},{130,120},
{130,110},{110,110},{110,130},{100,130},{100,150},{90,150}
}
polygon(WHITE,0,poly)
-- fill polygon
position(8,1)
puts(1,"Filling styles demo.")
position(10,1)
puts(1,"fill with horizontal lines")
Paint({102,102},WHITE,{GREEN,RED,BLUE},HORIZ)
pause()
Paint({102,102},WHITE,BLACK,PLAIN)
position(10,1)
puts(1,"fill with vertical lines  ")
Paint({102,102},WHITE,{GREEN,RED,BLUE},VERTI)
pause()
Paint({102,102},WHITE,BLACK,PLAIN)
position(10,1)
puts(1,"fill with slash lines     ")
Paint({102,102},WHITE,{GREEN,RED,BLUE},SLASH)
pause()
Paint({102,102},WHITE,BLACK,PLAIN)
position(10,1)
puts(1,"fill with back slash lines ")
Paint({102,102},WHITE,{GREEN,RED,BLUE},BKSLASH)
pause()
Paint({102,102},WHITE,BLACK,PLAIN)
position(10,1)
puts(1,"fill with chessboard squares")
Paint({102,102},WHITE,{GREEN,RED},CHESSB)

--Paint({50,50},WHITE,{BROWN,CYAN},CHESSB)
pause()
junk = graphics_mode(-1)


